class Solution {
    int dp[][];
    boolean isComputed[][];
    public int minimumTotal(List<List<Integer>> triangle) {
        dp = new int[triangle.size()][triangle.size()];
        isComputed = new boolean[triangle.size()][triangle.size()];
        
        int mn = Integer.MAX_VALUE;
        for (int i = 0; i < triangle.size(); ++i) {
            mn = Math.min(mn, minSum(triangle, triangle.size() - 1, i));
        }
        return mn;
    }
    
    public int minSum(List<List<Integer>> triangle, int i, int j) {
        if (isComputed[i][j]) return dp[i][j];
        dp[i][j] = triangle.get(i).get(j);
        if (i == 0 && j == 0) return dp[i][j];
        if (j == 0) dp[i][j] += minSum(triangle, i-1, j);
        else if (j == i) dp[i][j] += minSum(triangle, i-1, j-1);
        else dp[i][j] += Math.min(minSum(triangle, i-1, j), minSum(triangle, i-1, j-1));
        isComputed[i][j] = true;
        return dp[i][j];
    }
    
}
