class Solution {
    public int integerBreak(int n) {
        int dp[] = new int[n + 1];
        dp[1] = 1;
        for (int i = 2; i <= n; ++i) {
            dp[i] = i - 1;
            // If i is not the target, then we can make a product of i.
            if (i < n) dp[i] += 1;
            for (int j = 1; j < i; ++j) {
                dp[i] = Math.max(dp[i], j * dp[i - j]);
            }
        }
        return dp[n];
    }
}
