class Solution {
    public int countZeros(String s) {
        int zeros = 0;
        for (int i = 0; i < s.length(); ++i) {
            if (s.charAt(i) == '0') ++zeros;
        }
        return zeros;
    }
    public int findMaxForm(String[] strs, int m, int n) {
        int[][] dp = new int[m+1][n+1];
        dp[0][0] = 1;
        int mx = 1;
        for (int i = 0; i < strs.length; ++i) {
            int zeros = countZeros(strs[i]);
            int ones = strs[i].length() - zeros;
            for (int j = m; j >= zeros; --j) {
                for (int k = n; k >= ones; --k) {
                    if (dp[j-zeros][k-ones] >= 0) dp[j][k] = Math.max(dp[j][k], dp[j-zeros][k-ones] + 1);
                    mx = Math.max(mx, dp[j][k]);
                }
            }
        }
        return mx - 1;
    }
}
