package sort2;

public class Knapsack01 {

	// Returns the maximum value that can be put in a knapsack of capacity W 
	static int knapSack(int W, int wt[], int val[], int n) { 
        int dp[][] = new int[n+1][W + 1];
        boolean used[][] = new boolean[n+1][W + 1];
        for (int i = 1; i <= W; ++i) dp[0][i] = Integer.MIN_VALUE;
        int mx = 0, mxWeight = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = W; j >= wt[i]; --j) {
                if (dp[i][j - wt[i]] != Integer.MIN_VALUE && val[i] + dp[i][j - wt[i]] > dp[i][j]) {
                	dp[i+1][j] = val[i] + dp[i][j - wt[i]];
                	used[i+1][j] = true;
                } else {
                	dp[i+1][j] = dp[i][j];
                	// used[i+1][j] = false;
                }
                if (mx < dp[i+1][j]) {
                	mx = dp[i+1][j];
                	mxWeight = j;
                }
            }
            for (int j = 0; j < wt[i] && j < W; ++j) dp[i+1][j] = dp[i][j];
        }
        int curWeight = mxWeight, sm = 0;
        for (int i = n - 1; i >= 0; --i) {
        	if (used[i+1][curWeight]) {
        		System.out.println("(" + wt[i] + ", " + val[i] + ")");
        		curWeight -= wt[i];
        	}
        }
        
        return mx;
    }
}
