class Solution { 
    // Returns the maximum value that can be put in a knapsack of capacity W 
    static int knapSack(int W, int wt[], int val[], int n) { 
        int dp[] = new int[W + 1];
        for (int i = 1; i <= W; ++i) dp[i] = Integer.MIN_VALUE;
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = W; j >= wt[i]; --j) {
                if (dp[j - wt[i]] != Integer.MIN_VALUE)
                    dp[j] = Math.max(dp[j], val[i] + dp[j - wt[i]]);
                mx = Math.max(mx, dp[j]);
            }
        }
        return mx;
    } 
}
