class Solution {
    private int dp[][];
    public int longestCommonSubsequence(String A, String B) {
        dp = new int[A.length() + 1][B.length() + 1];
        for (int i = 0; i < A.length() + 1; ++i) {
            for (int j = 0; j < B.length() + 1; ++j) {
                dp[i][j] = -1;
            }
        }
        return lcs(A, B, A.length(), B.length());
    }
    
    public int lcs(String A, String B, int i, int j) {
        if (dp[i][j] != -1) return dp[i][j];
        if (i == 0 || j == 0) return 0;
        dp[i][j] = Math.max(lcs(A, B, i-1, j), lcs(A, B, i, j-1));
        if (A.charAt(i-1) == B.charAt(j-1)) 
            dp[i][j] = Math.max(lcs(A, B, i, j), lcs(A, B, i-1, j-1) + 1);
        return dp[i][j];
    }
}