class Solution {
    public int longestPalindromeSubseq(String s) {
        int dp[][] = new int[s.length()][s.length()];
        for (int len = 0; len < s.length(); ++len) {
            for (int i = 0; i + len < s.length(); ++i) {
                if (len == 0) dp[i][i] = 1;
                else if (len == 1) dp[i][i+1] = 1 + (s.charAt(i) == s.charAt(i+1) ? 1 : 0);
                else {
                    dp[i][i + len] = Math.max(dp[i][i + len - 1], dp[i+1][i + len]);
                    if (s.charAt(i) == s.charAt(i+len)) {
                        dp[i][i + len] = Math.max(dp[i][i + len], 2 + dp[i+1][i+len-1]);
                    }
                }
            }
        }
        return dp[0][s.length()-1];
    }
}
